#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <gtk/gtk.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "globals.h"

void init_temp_img(  )
{
	gchar *tempo;
	tempimg = strdup( "/tmp/xmmscoverXXXXXX" );
	tempo = mkdtemp( tempimg );
	tempdir = strdup( tempo );
	free( tempimg );
	tempimg = g_strdup_printf( "%s/coverviewer/pingoo.jpg", DATADIR );
}

void clean_temp(  )
{
	gchar *cmd;
	cmd = g_strdup_printf( "\\rm -r %s", tempdir );
	system( cmd );
	g_free( cmd );
}

void purge_temp(  )
{
	gchar *cmd;
	cmd = g_strdup_printf( "\\rm -r %s/*.img 2>/dev/null", tempdir );
	system( cmd );
	g_free( cmd );
}


gchar *up( gchar * str )
{
	char *buf;
	int i;
	i = strlen( str );
	buf = strdup( str );
	*( buf + i ) = 0;
	while( i >= 0 ) {
		*( buf + i ) = toupper( *( buf + i ) );
		i--;
	}
	return buf;
}

gchar *replace( gchar * str, gchar * oldchaine, gchar * newchaine )
{
	gchar *wstr, *temp, *pos;

	if( str == NULL || strlen( oldchaine ) == 0 ) {
		return NULL;
	}
	//printf("ENTREE : [%s] OLD : [%s] NEW [%s]\n",str,oldchaine,newchaine);
	wstr = strdup( str );
	free( str );
	while( ( pos = strstr( wstr, oldchaine ) ) != NULL ) {
		temp = ( gchar * ) malloc( strlen( wstr ) - strlen( oldchaine ) + strlen( newchaine ) + 1 );
		strncpy( temp, wstr, pos - wstr );
		temp[pos - wstr] = 0;
		strcat( temp, newchaine );
		strcat( temp, pos + strlen( oldchaine ) ),
			//temp[strlen(wstr)-strlen(oldchaine)+strlen(newchaine)]=0;
			free( wstr );
		wstr = temp;
	}
	return wstr;
}

gchar *find_file( gchar * path, gchar * filter )
{
	gchar *temp, *name;
	DIR *dir;
	struct dirent *files;
	struct stat buf;

	dir = opendir( path );
	if( dir != NULL ) {
		while( ( files = readdir( dir ) ) != NULL ) {
			if( !strcmp( files->d_name, "." ) || !strcmp( files->d_name, ".." ) ) {
				continue;
			}
			temp = malloc( strlen( path ) + strlen( files->d_name ) + 2 );
			strcpy( temp, path );
			strcat( temp, "/" );
			strcat( temp, files->d_name );
			stat( temp, &buf );
			if( S_ISDIR( buf.st_mode ) ) {
				//Rpertoire
				name = find_file( temp, filter );
				free( temp );
				if( name ) {
					//Trouv!
					closedir( dir );
					return name;
				}
			} else {
				//FILE
				name = up( files->d_name );
				if( strcmp( name, filter ) == 0 ) {
					//Trouv
					closedir( dir );
					free( name );
					return temp;
				}
				free(temp);
				free(name);
			}
		}
	}
	closedir( dir );
	return NULL;
}

gchar *exists_file( gchar * path, gchar * filter, gchar * ext )
{
	gchar *name, *temp;
	DIR *dir;
	struct dirent *files;

	dir = opendir( path );
	if( dir != NULL ) {
		while( ( files = readdir( dir ) ) != NULL ) {
			temp = malloc( strlen( path ) + strlen( files->d_name ) + 2 );
			strcpy( temp, path );
			strcat( temp, "/" );
			strcat( temp, files->d_name );
			name = up( files->d_name );
			if( strstr( name, filter ) != NULL && strstr( name, ext ) != NULL ) {
				//Trouv
				free( name );
				closedir( dir );
				return temp;
			}
			free( temp );
			free( name );
		}
	}
	closedir( dir );
	return NULL;
}


gint count_lines( gchar * str )
{
	gint lines = 0;
	gint i = 0;

	if( str == NULL )
		return 0;

	while( str[i] != '\0' ) {
		if( str[i] == '\n' )
			lines++;
		i++;
	}
	return lines;
}

gchar *get_line( gint number, gchar * str )
{
	gint i = 0;

	if( str == NULL )
		return NULL;

	while( str[i] != '\0' ) {
		if( str[i] == '\n' && --number <= 0 )
			break;
		i++;
	}
	return str + i + 1;
}

/* pops the next line of a string */
gchar *nextline( char **str )
{
	char *line = *str;
	char *lineend = index( *str, '\n' );
	if( lineend != NULL ) {
		*str = lineend + 1;
		*lineend = '\0';
	}
	return line;
}

guint hex_chars_to_int( gchar c, gchar d )
{
	/* (from xmms)
	 * Converts a value in the range 0x00-0xFF
	 * to a integer in the range 0-65535
	 */
	gchar str[3];

	str[0] = c;
	str[1] = d;
	str[2] = '\0';

	return ( CLAMP( strtol( str, NULL, 16 ), 0, 255 ) * 256 );
}

gchar *net_purge( gchar * str )
{
	gchar *temp;
	if( str ) {
		temp = strdup( str );
		free( str );
		temp = replace( temp, "#", " " );
		temp = replace( temp, "*", " " );
		temp = replace( temp, "?", " " );
		temp = replace( temp, "(", " " );
		temp = replace( temp, ")", "" );
		temp = replace( temp, "\'", "\\ZOGZOG" );
		temp = replace( temp, "`", "\\ZOGZOG" );
		temp = replace( temp, "ZOGZOG", "\'" );
		temp = replace( temp, "\"", "" );
		temp = replace( temp, ":", " " );
		temp = replace( temp, "&", " " );
		temp = replace( temp, "/", " " );
		temp = replace( temp, "  ", " " );
		return temp;
	} else
		return NULL;
}

gchar *purge( gchar * str )
{
	gchar *title;

	//char fakestr[3];

	if( str ) {
		title = ( gchar * ) strdup( str );
		free( str );

/*	Now thos are cleared by UTF8_DECODE
	title=replace(title,"è","");
	title=replace(title,"é","");
	title=replace(title,"ê","");
	title=replace(title,"à","");
	title=replace(title,"û","");
	title=replace(title,"ù","");
	title=replace(title,"â","");
	title=replace(title,"ï","");
	title=replace(title,"ç","");
	title=replace(title,"¿","");
	title=replace(title,"ó","");
	title=replace(title,"ö","");
	fakestr[0]=0xC3; fakestr[1]=0x89; fakestr[2]=0;
	title=replace(title,(gchar *) &fakestr[0],"");
	title=replace(title,"°","");
	title=replace(title,"¡","");
	title=replace(title,"%20"," ");
	fakestr[0]=0xC3; fakestr[1]=0xB4; fakestr[2]=0;  
	title=replace(title,(gchar *) &fakestr[0],"");*/
		// ' display
		title = replace( title, "", "'" );
		return title;
	} else
		return NULL;
}

gchar *strip_end_spaces( gchar * string )
{
	gchar *tmp, *pos, *pos2;
	if( !string ) {
		return NULL;
	}
	tmp = ( gchar * ) strdup( string );
	pos = tmp + strlen( string ) - 1;
	/* end_spaces */
	while( pos >= tmp && ( pos[0] == 32 || pos[0] == 13 || pos[0] == 10 ) ) {
		pos[0] = 0;
		pos--;
	}
	pos2 = tmp;
	/* start_spaces */
	while( pos2[0] == 32 )
		pos2++;
	pos2 = ( gchar * ) strdup( pos2 );
	if( pos != tmp - 1 ) {
		free( tmp );
		return pos2;
	}
	free( tmp );
	return NULL;
}

gchar *utf8_decode( gchar * str )
{
	gchar *temp, *in, *out;
	unsigned int c, d;
	if( str ) {
		temp = ( gchar * ) malloc( strlen( str ) * 2 + 1 );
		out = temp;
		in = str;
		while( ( c = *in++ ) != 0 ) {
			if( c < 0x80 )
				*out++ = c;
			else {
				d = *in++;
				/* hack for displaying ' */
				if( ( d & 0xFF ) == 0x92 && ( c & 0xFF ) == 0xc2 )
					*out++ = 0x27;
				else
					*out++ = ( ( d & 0x3F ) | ( ( c & 0x03 ) << 6 ) );
			}
		}
		*out = 0;
		out = ( gchar * ) strdup( temp );
		g_free( temp );
		g_free( str );
		return out;
	} else
		return NULL;
}


gchar *utf8_encode( gchar * str )
{
	gchar *temp, *in, *out;
	unsigned int c;
	temp = ( gchar * ) malloc( strlen( str ) * 2 + 1 );
	out = temp;
	in = str;
	while( ( c = *in++ ) != 0 ) {
		if( c < 0x80 )
			*out++ = c;
		else {
			*out++ = ( ( ( c & 0xC0 ) >> 6 ) | 0xC0 );
			*out++ = ( ( c & 0x3F ) | 0x80 );
		}
	}
	*out = 0;
	out = ( gchar * ) strdup( temp );
	g_free( temp );
	g_free( str );
	return out;
}


gchar *strip_html( gchar * str )
{
	gchar *temp, *tagstart, *tagend, fakestr[2];
	fakestr[0] = 0x0D;
	fakestr[1] = 0;
	temp = replace( str, &fakestr[0], "" );
	fakestr[0] = 0x0A;
	//temp=replace(temp,&fakestr[0],"");

	/* line carriage */
	temp = replace( temp, "<BR>\n", "\n" );
	temp = replace( temp, "<BR/>\n", "\n" );
	temp = replace( temp, "<BR />\n", "\n" );
	temp = replace( temp, "<br>\n", "\n" );
	temp = replace( temp, "<br/>\n", "\n" );
	temp = replace( temp, "<br />\n", "\n" );
	temp = replace( temp, "<BR>", "\n" );
	temp = replace( temp, "<BR/>", "\n" );
	temp = replace( temp, "<BR />", "\n" );
	temp = replace( temp, "<br>", "\n" );
	temp = replace( temp, "<br/>", "\n" );
	temp = replace( temp, "<br />", "\n" );

	/* tabs */
	temp = replace( temp, "&nbsp;", "\t" );

	while( ( tagstart = strstr( temp, "<!--" ) ) ) {	/* Javascript tag */
		tagend = strstr( tagstart, "-->" );
		if( tagend && tagend > tagstart ) {
			tagend = ( gchar * ) g_strndup( tagstart, tagend - tagstart + 3 );
			temp = replace( temp, tagend, "\n" );
			free( tagend );
		} else
			break;
	}
	while( ( tagstart = strstr( temp, "<script" ) ) ) {	/* Script tag */
		tagend = strstr( tagstart, "/script>" );
		if( tagend && tagend > tagstart ) {
			tagend = ( gchar * ) g_strndup( tagstart, tagend - tagstart + 8 );
			temp = replace( temp, tagend, "\n" );
			free( tagend );
		} else
			break;
	}
	while( ( tagstart = strstr( temp, "<SCRIPT" ) ) ) {	/* Script tag */
		tagend = strstr( tagstart, "/SCRIPT>" );
		if( tagend && tagend > tagstart ) {
			tagend = ( gchar * ) g_strndup( tagstart, tagend - tagstart + 8 );
			temp = replace( temp, tagend, "\n" );
			free( tagend );
		} else
			break;
	}
	while( ( tagstart = strchr( temp, '<' ) ) ) {	/* Html tag */
		tagend = strchr( tagstart, '>' );
		if( tagend && tagend > tagstart ) {
			tagend = ( gchar * ) g_strndup( tagstart, tagend - tagstart + 1 );
			temp = replace( temp, tagend, "\n" );
			free( tagend );
		} else
			break;
	}

	/* excedent spaces */
	temp = replace( temp, "  ", " " );
	temp = replace( temp, "\t\n", "\n" );
	temp = replace( temp, " \n", "\n" );
	temp = replace( temp, "\n\n\n", "\n" );

	return temp;
}
